hdu 1142 A Walk Through the Forest (digkstra+记忆化搜索)

A Walk Through the Forest

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 7322    Accepted Submission(s): 2685

Problem Description

Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer, his office is on one side of a forest, and his house is on the other. A
nice walk through the forest, seeing the birds and chipmunks is quite enjoyable.

The forest is beautiful, and Jimmy wants to take a different route everyday. He also wants to get home before dark, so he always takes a path to make progress towards his house. He considers taking a path from A to B to be progress if there exists a route from
B to his home that is shorter than any possible route from A. Calculate how many different routes through the forest Jimmy might take.

Input

Input contains several test cases followed by a line containing 0. Jimmy has numbered each intersection or joining of paths starting with 1. His office is numbered 1, and his house is numbered 2. The first line of each test case gives the number of intersections
N, 1 < N ≤ 1000, and the number of paths M. The following M lines each contain a pair of intersections a b and an integer distance 1 ≤ d ≤ 1000000 indicating a path of length d between intersection a and a different intersection b. Jimmy may walk a path any
direction he chooses. There is at most one path between any pair of intersections.

Output

For each test case, output a single integer indicating the number of different routes through the forest. You may assume that this number does not exceed 2147483647

Sample Input

5 6
1 3 2
1 4 2
3 4 3
1 5 12
4 2 34
5 2 24
7 8
1 3 1
1 4 1
3 7 1
7 4 1
7 5 1
6 7 1
5 2 1
6 2 1
0

Sample Output

2
4

Source

University of Waterloo Local Contest 2005.09.24

Recommend

Eddy   |   We have carefully selected several similar problems for you:  1217 1385 1162 1596 2112

Statistic | Submit | Discuss | Note

没有过英语四级的渣渣 果然不能做这道题。。

理解为求最短路径的个数了  。主要就是看这句话He considers taking a path from A to B to be progress if there exists a route from B to his home that is shorter than any possible route from A.   大概意思就是 如果A-B有路  并且我想从A走到B那么有条件就是A到2的距离要大于B到2的距离

思路:

1.digkstra算法求出各点到2-1的最短距离 同时存贮其它点到2的最短距离

2.记忆化搜索 从1开始 找到符合条件的路径数

#include <stdio.h>
#include <vector>
#include <string.h>
#include <queue>
#include <algorithm>
using namespace std;
int min_path;
int min_count;
//存贮当前点到2的最短路径
int dis[1005];
//记忆化搜索时存贮路径数
int dp[1005];
int n;
//digkstra算法和记忆化搜索时 判断是否已经走过某点
bool vis[1005];
struct node
{
	int pos;
	int cost;
	bool friend operator<(node x,node y)
	{
		return x.cost>y.cost;
	}
};
//存贮边
vector<node>map[1005];
int digkstra(int x)
{
	priority_queue<node>s;
	memset(vis,false,sizeof(vis));
	memset(dis,100,sizeof(dis));
	node temp,temp1;
	temp.pos=x;temp.cost=0;
	s.push(temp);
	while(!s.empty())
	{
		temp=temp1=s.top();s.pop();
		vis[temp.pos]=true;
		dis[temp.pos]=min(dis[temp.pos],temp.cost);
		if(temp.pos==1)
		return temp.cost;
		for(int i=0;i<map[temp.pos].size();i++)
		{
			int x=map[temp.pos][i].pos;
			int y=map[temp.pos][i].cost;
			if(!vis[x])
			{
				temp.pos=x;
				temp.cost+=y;
				s.push(temp);
			}
			temp=temp1;
		}
	}
	return -1;
}
//记忆化搜索
int dfs(int pos,int sum)
{
	if(dp[pos]) return dp[pos];
	if(pos==2) return 1;
	int result=0;
	for(int i=0;i<map[pos].size();i++)
	{
		int x=map[pos][i].pos;
		int y=map[pos][i].cost;
		//pos->x有路  并且满足pos到2的最短路径大于x到2的最短路径
		if(!vis[x]&&dis[pos]>dis[x])
		{
			vis[x]=true;
			result+=dfs(x,sum+y);
			vis[x]=false;
		}
	}
	dp[pos]=result;
	return dp[pos];
}
int main()
{
	while(~scanf("%d",&n)&&n)
	{
		int m;
		scanf("%d",&m);
		memset(map,0,sizeof(map));
		for(int i=0;i<m;i++)
		{
			int a,b,x;
			scanf("%d %d %d",&a,&b,&x);
			node temp;
			temp.pos=b;temp.cost=x;
			map[a].push_back(temp);
			temp.pos=a;
			map[b].push_back(temp);
		}
		min_path=digkstra(2);
		min_count=0;
		memset(vis,false,sizeof(vis));
		memset(dp,0,sizeof(dp));
		vis[1]=true;
		printf("%d\n",dfs(1,0));
	}
	return 0;
}
时间: 2024-10-11 07:35:09

hdu 1142 A Walk Through the Forest (digkstra+记忆化搜索)的相关文章

HDU 1142 A Walk Through the Forest (Dijkstra + 记忆化搜索 好题)

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 6350    Accepted Submission(s): 2332 Problem Description Jimmy experiences a lot of stress at work these days, especial

HDU 1142 A Walk Through the Forest (记忆化搜索+Dijkstra算法)

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7583    Accepted Submission(s): 2791 Problem Description Jimmy experiences a lot of stress at work these days, especial

HDU 1142 A Walk Through the Forest【记忆化搜索+最短路Dijkstra算法】

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 7601    Accepted Submission(s): 2796 Problem Description Jimmy experiences a lot of stress at work these days, especial

HDU 1142 A Walk Through the Forest(dijkstra+记忆化DFS)

题意: 给你一个图,找最短路.但是有个非一般的的条件:如果a,b之间有路,且你选择要走这条路,那么必须保证a到终点的所有路都小于b到终点的一条路.问满足这样的路径条数 有多少,噶呜~~题意是搜了解题报告才明白的Orz....英语渣~ 思路: 1.1为起点,2为终点,因为要走ab路时,必须保证那个条件,所以从终点开始使用单源最短路Dijkstra算法,得到每个点到终点的最短路,保存在dis[]数组中. 2.然后从起点开始深搜每条路,看看满足题意的路径有多少条. 3.这样搜索之后,dp[1]就是从起

题解报告:hdu 1142 A Walk Through the Forest

题目链接:acm.hdu.edu.cn/showproblem.php?pid=1142 Problem Description Jimmy experiences a lot of stress at work these days, especially since his accident made working difficult. To relax after a hard day, he likes to walk home. To make things even nicer,

hdu 1142 A Walk Through the Forest (最短路+dfs )

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5809    Accepted Submission(s): 2147 Problem Description Jimmy experiences a lot of stress at work these days, especial

HDU - 1142 A Walk Through the Forest(Dijkstra+DFS)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1142 题意:从1到达2,路径要尽可能短(就先一遍dijkstra),并且要求每次距离2的路径要比上一个点距离2的路径近,求有多少符合条件的线路. 以2为起始点先进行一遍dijkstra,然后再从1开始dfs,寻找符合条件的线路(就是可以搜到2的线路). #include <bits/stdc++.h> using namespace std; const int INF=0x3f3f3f3f; c

hdu 1142 A Walk Through the Forest (Dijkstra + 记忆化搜索)

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 5984    Accepted Submission(s): 2211 Problem Description Jimmy experiences a lot of stress at work these days, especial

HDU 1142 A Walk Through the Forest(最短路+记忆化搜索)

A Walk Through the Forest Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 10172    Accepted Submission(s): 3701 Problem Description Jimmy experiences a lot of stress at work these days, especial